#!/usr/bin/env python
'''
  #############################################################################
  #
  #     This Cplant(TM) source code is the property of Sandia National
  #     Laboratories.
  #
  #     This Cplant(TM) source code is copyrighted by Sandia National
  #     Laboratories.
  #
  #     The redistribution of this Cplant(TM) source code is subject to the
  #     terms of the GNU Lesser General Public License
  #     (see cit/LGPL or http://www.gnu.org/licenses/lgpl.html)
  #
  #     Cplant(TM) Copyright 1998, 1999, 2000, 2001, 2002 Sandia Corporation.
  #     Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
  #     license for use of this work by or on behalf of the US Government.
  #     Export of this program may require a license from the United States
  #     Government.
  #
  #############################################################################

File: errorhandlers.py
Author: William McLendon & Narayan Desai
Revision: $Revision: 1.3 $
Description:
  Error handling routines and exceptions for APITEST
'''
from exceptions import Exception

class TestSetupError(Exception):
    pass

class TestDescriptionError(Exception):
    pass

class TestFailure(Exception):
    def __init__(self,name,nFail):
        self.name=name
        self.onMismatch=onMismatch
        
    def __str__(self):
        return `self.name` + " failure"

class TestError(Exception):
    def __init__(self, _message):
        self.message = _message
    def __str__(self):
        return `self.message`



# EOF
