#! /usr/bin/env python

### PGM 1

from threading    import *

from xml.dom.minidom import Document
from sss.server import SSSSelectEventReceiver

class HandleSSSEvents(SSSSelectEventReceiver):
    def HandleXMLEvent(self, xe, (peer,port)):
        i = 0
        for event in xe.childNodes:
            #print event.toxml()
            if event.hasAttribute('component'):
                component = event.getAttribute('component')
                data = event.getAttribute('data')
                msg = event.getAttribute('msg')
                #print 'RMB: component=%s data=%s msg=%s' % (component,data,msg)
                wxCallAfter(chg_box,"black", component)
        response=Document().createElement('event-ok')
        return response

def worker_code(server):
    server.ServeForever()

component = "**"
msg = "**"
data = "**"
debug = 0
server = HandleSSSEvents(component=component,msg=msg,data=data,debug=debug)
worker = Thread(target=worker_code,args=(server,))
worker.setDaemon(1)
worker.start()


### PGM 2

from wxPython.wx  import *
from wxPython.ogl import *
from random import randrange
from math import sqrt

wxOGLInitialize()                       # Initialize OGL

class MyAppFrame(wxFrame):
    def __init__(self,*args,**kwds):
        wxFrame.__init__(self,*args,**kwds)

        self.SetTitle("SSS Component Design")   # Frame name
        self.SetSize((1024,768))           # Size of the Window
        self.canvas = OGLCanvas(self,self)      # create canvas


class OGLCanvas(wxShapeCanvas):
    def __init__(self, parent, frame):
        wxShapeCanvas.__init__(self, parent)
        
        self.SetBackgroundColour("Light Grey")
        self.diagram = wxDiagram()      # we are going to draw a diagram
        self.SetDiagram(self.diagram)   # attach diagram to canvas
        self.diagram.SetCanvas(self)    # attach canvas to diagram
        #set up all the Brushes I want to use
        self.OrangeBrush = wxBrush(wxNamedColor("Orange"), wxSOLID)
        self.YellowBrush = wxBrush(wxNamedColor("Yellow"), wxSOLID)
        self.PinkBrush = wxBrush(wxNamedColor("Pink"), wxSOLID)
        self.GreenBrush = wxBrush(wxNamedColor("Green"), wxSOLID)
        self.BlueBrush = wxBrush(wxNamedColor("Blue"), wxSOLID)

        
        self.box1 = wxCircleShape(150) # create a box
        self.box1.SetCanvas(self)       # attach to canvas separately
        self.box1.SetX(175)                      # locate X coord
        self.box1.SetY(125)                      # locate Y coord
        self.box1.SetBrush(self.OrangeBrush)
        self.box1.AddText("Access & Security Manager")       # label it
        self.diagram.AddShape(self.box1)               # add to canvas


        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box1)
        self.evthandler.SetPreviousHandler(self.box1.GetEventHandler())
        self.box1.SetEventHandler(self.evthandler)

        # Note that box2 is actually a circle
        self.box2 = wxCircleShape(100) # create another box
        self.box2.SetX(400)                      # locate X coord
        self.box2.SetY(100)                      # locate Y coord
        self.box2.SetBrush(self.YellowBrush)
        self.box2.AddText("Meta Scheduler")     # label it
        self.diagram.AddShape(self.box2)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box2)
        self.evthandler.SetPreviousHandler(self.box2.GetEventHandler())
        self.box2.SetEventHandler(self.evthandler)


        self.box3 = wxCircleShape(100) # create a box
        self.box3.SetCanvas(self)       # attach to canvas separately
        self.box3.SetX(600)                      # locate X coord
        self.box3.SetY(100)                      # locate Y coord
        self.box3.SetBrush(self.PinkBrush)
        self.box3.AddText("Meta Monitor")       # label it
        self.diagram.AddShape(self.box3)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box3)
        self.evthandler.SetPreviousHandler(self.box3.GetEventHandler())
        self.box3.SetEventHandler(self.evthandler)


        self.box4 = wxCircleShape(100) # create a box
        self.box4.SetCanvas(self)       # attach to canvas separately
        self.box4.SetX(800)                      # locate X coord
        self.box4.SetY(100)                      # locate Y coord
        self.box4.SetBrush(self.OrangeBrush)
        self.box4.AddText("Meta Manager")       # label it
        self.diagram.AddShape(self.box4)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box4)
        self.evthandler.SetPreviousHandler(self.box4.GetEventHandler())
        self.box4.SetEventHandler(self.evthandler)

        self.box5 = wxCircleShape(100) # create a box
        self.box5.SetCanvas(self)       # attach to canvas separately
        self.box5.SetX(100)                      # locate X coord
        self.box5.SetY(275)                      # locate Y coord
        self.box5.SetBrush(self.YellowBrush)
        self.box5.AddText("Accounting Manager")       # label it
        self.diagram.AddShape(self.box5)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box5)
        self.evthandler.SetPreviousHandler(self.box5.GetEventHandler())
        self.box5.SetEventHandler(self.evthandler)

        self.box6 = wxCircleShape(100) # create a box
        self.box6.SetCanvas(self)       # attach to canvas separately
        self.box6.SetX(400)                      # locate X coord
        self.box6.SetY(250)                      # locate Y coord
        self.box6.SetBrush(self.YellowBrush)
        self.box6.AddText("Scheduler")       # label it
        self.diagram.AddShape(self.box6)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box6)
        self.evthandler.SetPreviousHandler(self.box6.GetEventHandler())
        self.box6.SetEventHandler(self.evthandler)


        self.box7 = wxCircleShape(100) # create a box
        self.box7.SetCanvas(self)       # attach to canvas separately
        self.box7.SetX(650)                      # locate X coord
        self.box7.SetY(250)                      # locate Y coord
        self.box7.SetBrush(self.PinkBrush)
        self.box7.AddText("System Monitor")       # label it
        self.diagram.AddShape(self.box7)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box7)
        self.evthandler.SetPreviousHandler(self.box7.GetEventHandler())
        self.box7.SetEventHandler(self.evthandler)

        self.box8 = wxCircleShape(150) # create a box
        self.box8.SetCanvas(self)       # attach to canvas separately
        self.box8.SetX(850)                      # locate X coord
        self.box8.SetY(300)                      # locate Y coord
        self.box8.SetBrush(self.OrangeBrush)
        self.box8.AddText("Build & Config Manager")       # label it
        self.diagram.AddShape(self.box8)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box8)
        self.evthandler.SetPreviousHandler(self.box8.GetEventHandler())
        self.box8.SetEventHandler(self.evthandler)

        self.box9 = wxCircleShape(100) # create a box
        self.box9.SetCanvas(self)       # attach to canvas separately
        self.box9.SetX(250)                      # locate X coord
        self.box9.SetY(360)                      # locate Y coord
        self.box9.SetBrush(self.YellowBrush)
        self.box9.AddText("Allocation Manager")       # label it
        self.diagram.AddShape(self.box9)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box9)
        self.evthandler.SetPreviousHandler(self.box9.GetEventHandler())
        self.box9.SetEventHandler(self.evthandler)

        self.box10 = wxCircleShape(100) # create a box
        self.box10.SetCanvas(self)       # attach to canvas separately
        self.box10.SetX(125)                      # locate X coord
        self.box10.SetY(475)                      # locate Y coord
        self.box10.SetBrush(self.OrangeBrush)
        self.box10.AddText("User Manager")       # label it
        self.diagram.AddShape(self.box10)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box10)
        self.evthandler.SetPreviousHandler(self.box10.GetEventHandler())
        self.box10.SetEventHandler(self.evthandler)

        self.box11 = wxCircleShape(100) # create a box
        self.box11.SetCanvas(self)       # attach to canvas separately
        self.box11.SetX(375)                      # locate X coord
        self.box11.SetY(475)                      # locate Y coord
        self.box11.SetBrush(self.YellowBrush)
        self.box11.AddText("Queue Manager")       # label it
        self.diagram.AddShape(self.box11)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box11)
        self.evthandler.SetPreviousHandler(self.box11.GetEventHandler())
        self.box11.SetEventHandler(self.evthandler)


        self.box12 = wxCircleShape(100) # create a box
        self.box12.SetCanvas(self)       # attach to canvas separately
        self.box12.SetX(600)                      # locate X coord
        self.box12.SetY(425)                      # locate Y coord
        self.box12.SetBrush(self.PinkBrush)
        self.box12.AddText("Process Manager")       # label it
        self.diagram.AddShape(self.box12)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box12)
        self.evthandler.SetPreviousHandler(self.box12.GetEventHandler())
        self.box12.SetEventHandler(self.evthandler)


        self.box13 = wxCircleShape(100) # create a box
        self.box13.SetCanvas(self)       # attach to canvas separately
        self.box13.SetX(850)                      # locate X coord
        self.box13.SetY(500)                      # locate Y coord
        self.box13.SetBrush(self.PinkBrush)
        self.box13.AddText("Data Migration")       # label it
        self.diagram.AddShape(self.box13)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box13)
        self.evthandler.SetPreviousHandler(self.box13.GetEventHandler())
        self.box13.SetEventHandler(self.evthandler)


        self.box14 = wxCircleShape(100) # create a box
        self.box14.SetCanvas(self)       # attach to canvas separately
        self.box14.SetX(80)                      # locate X coord
        self.box14.SetY(600)                      # locate Y coord
        self.box14.SetBrush(self.YellowBrush)
        self.box14.AddText("Usage Reporter")       # label it
        self.diagram.AddShape(self.box14)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box14)
        self.evthandler.SetPreviousHandler(self.box14.GetEventHandler())
        self.box14.SetEventHandler(self.evthandler)


        self.box15 = wxCircleShape(100) # create a box
        self.box15.SetCanvas(self)       # attach to canvas separately
        self.box15.SetX(225)                      # locate X coord
        self.box15.SetY(600)                      # locate Y coord
        self.box15.SetBrush(self.OrangeBrush)
        self.box15.AddText("User Utilities")       # label it
        self.diagram.AddShape(self.box15)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box15)
        self.evthandler.SetPreviousHandler(self.box15.GetEventHandler())
        self.box15.SetEventHandler(self.evthandler)


        self.box16 = wxCircleShape(150) # create a box
        self.box16.SetCanvas(self)       # attach to canvas separately
        self.box16.SetX(400)                      # locate X coord
        self.box16.SetY(650)                      # locate Y coord
        self.box16.SetBrush(self.GreenBrush)
        self.box16.AddText("High Performance I/O")
        self.diagram.AddShape(self.box16)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box16)
        self.evthandler.SetPreviousHandler(self.box16.GetEventHandler())
        self.box16.SetEventHandler(self.evthandler)


        self.box17 = wxCircleShape(100) # create a box
        self.box17.SetCanvas(self)       # attach to canvas separately
        self.box17.SetX(575)                      # locate X coord
        self.box17.SetY(600)                      # locate Y coord
        self.box17.SetBrush(self.PinkBrush)
        self.box17.AddText("CheckPoint/Restart")       # label it
        self.diagram.AddShape(self.box17)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box17)
        self.evthandler.SetPreviousHandler(self.box17.GetEventHandler())
        self.box17.SetEventHandler(self.evthandler)


        self.box18 = wxCircleShape(100) # create a box
        self.box18.SetCanvas(self)       # attach to canvas separately
        self.box18.SetX(750)                      # locate X coord
        self.box18.SetY(600)                      # locate Y coord
        self.box18.SetBrush(self.GreenBrush)
        self.box18.AddText("File System")       # label it
        self.diagram.AddShape(self.box18)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box18)
        self.evthandler.SetPreviousHandler(self.box18.GetEventHandler())
        self.box18.SetEventHandler(self.evthandler)


        self.box19 = wxCircleShape(100) # create a box
        self.box19.SetCanvas(self)       # attach to canvas separately
        self.box19.SetX(900)                      # locate X coord
        self.box19.SetY(675)                      # locate Y coord
        self.box19.SetBrush(self.BlueBrush)
        self.box19.AddText("Testing & Validation")       # label it
        self.diagram.AddShape(self.box19)               # add to canvas

        self.evthandler = MyEvtHandler()
        self.evthandler.SetShape(self.box19)
        self.evthandler.SetPreviousHandler(self.box19.GetEventHandler())
        self.box19.SetEventHandler(self.evthandler)


        # add the connectors
        line1 = MyLineShape()
        line1.SetCanvas(self)
        self.box2.AddLine(line1, self.box6)
        self.diagram.AddShape(line1)

        line2 = MyLineShape()
        line2.SetCanvas(self)
        self.box3.AddLine(line2, self.box7)
        self.diagram.AddShape(line2)

        line3 = MyLineShape()
        line3.SetCanvas(self)
        self.box4.AddLine(line3, self.box8)
        self.diagram.AddShape(line3)

        line4 = MyLineShape()
        line4.SetCanvas(self)
        self.box5.AddLine(line4, self.box6)
        self.diagram.AddShape(line4)

        line5 = MyLineShape()
        line5.SetCanvas(self)
        self.box5.AddLine(line5, self.box10)
        self.diagram.AddShape(line5)

        line6 = MyLineShape()
        line6.SetCanvas(self)
        self.box5.AddLine(line6, self.box14)
        self.diagram.AddShape(line6)

        line7 = MyLineShape()
        line7.SetCanvas(self)
        self.box6.AddLine(line7, self.box9)
        self.diagram.AddShape(line7)

        line8 = MyLineShape()
        line8.SetCanvas(self)
        self.box7.AddLine(line8, self.box6)
        self.diagram.AddShape(line8)

        line9 = MyLineShape()
        line9.SetCanvas(self)
        self.box6.AddLine(line9, self.box11)
        self.diagram.AddShape(line9)

        line10 = MyLineShape()
        line10.SetCanvas(self)
        self.box15.AddLine(line10, self.box6)
        self.diagram.AddShape(line10)

        line11 = MyLineShape()
        line11.SetCanvas(self)
        self.box7.AddLine(line11, self.box17)
        self.diagram.AddShape(line11)

        line12 = MyLineShape()
        line12.SetCanvas(self)
        self.box7.AddLine(line12, self.box8)
        self.diagram.AddShape(line12)

        line13 = MyLineShape()
        line13.SetCanvas(self)
        self.box7.AddLine(line13, self.box12)
        self.diagram.AddShape(line13)

        line14 = MyLineShape()
        line14.SetCanvas(self)
        self.box8.AddLine(line14, self.box11)
        self.diagram.AddShape(line14)

        line15 = MyLineShape()
        line15.SetCanvas(self)
        self.box8.AddLine(line15, self.box12)
        self.diagram.AddShape(line15)

        line16 = MyLineShape()
        line16.SetCanvas(self)
        self.box9.AddLine(line16, self.box10)
        self.diagram.AddShape(line16)

        line17 = MyLineShape()
        line17.SetCanvas(self)
        self.box11.AddLine(line17, self.box10)
        self.diagram.AddShape(line17)

        line18 = MyLineShape()
        line18.SetCanvas(self)
        self.box11.AddLine(line18, self.box12)
        self.diagram.AddShape(line18)

        line19 = MyLineShape()
        line19.SetCanvas(self)
        self.box11.AddLine(line19, self.box17)
        self.diagram.AddShape(line19)

        line20 = MyLineShape()
        line20.SetCanvas(self)
        self.box12.AddLine(line20, self.box13)
        self.diagram.AddShape(line20)

        line21 = MyLineShape()
        line21.SetCanvas(self)
        self.box12.AddLine(line21, self.box17)
        self.diagram.AddShape(line21)

        line22 = MyLineShape()
        line22.SetCanvas(self)
        self.box12.AddLine(line22, self.box16)
        self.diagram.AddShape(line22)

        line23 = MyLineShape()
        line23.SetCanvas(self)
        self.box15.AddLine(line23, self.box12)
        self.diagram.AddShape(line23)



        self.diagram.ShowAll(1)                  # display all objects in diagram

        # for some reason, the shapes have to be moved for the line to show up.
        dc = wxClientDC(self)
        self.box1.Move(dc, self.box1.GetX(), self.box1.GetY())
        self.box2.Move(dc, self.box2.GetX(), self.box2.GetY())
        self.box3.Move(dc, self.box3.GetX(), self.box3.GetY())
        self.box4.Move(dc, self.box4.GetX(), self.box4.GetY())
        self.box5.Move(dc, self.box5.GetX(), self.box5.GetY())
        self.box6.Move(dc, self.box6.GetX(), self.box6.GetY())
        self.box7.Move(dc, self.box7.GetX(), self.box7.GetY())
        self.box8.Move(dc, self.box8.GetX(), self.box8.GetY())
        self.box9.Move(dc, self.box9.GetX(), self.box9.GetY())
        self.box10.Move(dc, self.box10.GetX(), self.box10.GetY())
        self.box11.Move(dc, self.box11.GetX(), self.box11.GetY())
        self.box12.Move(dc, self.box12.GetX(), self.box12.GetY())
        self.box13.Move(dc, self.box13.GetX(), self.box13.GetY())
        self.box14.Move(dc, self.box14.GetX(), self.box14.GetY())
        self.box15.Move(dc, self.box15.GetX(), self.box15.GetY())
        self.box16.Move(dc, self.box16.GetX(), self.box16.GetY())
        self.box17.Move(dc, self.box17.GetX(), self.box17.GetY())
        self.box18.Move(dc, self.box18.GetX(), self.box18.GetY())
        self.box19.Move(dc, self.box19.GetX(), self.box19.GetY())

class MyLineShape(wxLineShape):
    
    def __init__(self):
        wxLineShape.__init__(self)
        self.SetPen(wxBLACK_PEN)
        self.SetBrush(wxBLACK_BRUSH)
        self.AddArrow(ARROW_ARROW)
        self.MakeLineControlPoints(2)
        
class MyEvtHandler(wxShapeEvtHandler):

    def __init__(self):
        wxShapeEvtHandler.__init__(self)

    def OnLeftClick(self, x, y, keys = 0, attachment = 0):
        shape = self.GetShape()
        canvas = shape.GetCanvas()
        origX = shape.GetX()
        origY = shape.GetY()
        for newX in range(origX,origX+25):
            dc = wxClientDC(canvas)
            canvas.PrepareDC(dc)
            shape.Move(dc, newX, origY)
        for newX in range(origX+25,origX-25,-1):
            dc = wxClientDC(canvas)
            canvas.PrepareDC(dc)
            shape.Move(dc, newX, origY)
        for newX in range(origX-25,origX):
            dc = wxClientDC(canvas)
            canvas.PrepareDC(dc)
            shape.Move(dc, newX, origY)
        canvas.PrepareDC(dc)
        shape.Move(dc, origX, origY)
        canvas.Refresh()
        
    def OnRightClick(self, x, y, keys = 0, attachment = 0):
        shape = self.GetShape()
        canvas = shape.GetCanvas()
        shapebrush = shape.GetBrush()
        shapebrush.SetColour(wxNamedColor("white"))
        canvas.Refresh()    # can take args, e.g False as first arg (documentation?)

###############################################################################

class Main(wxApp):
    def OnInit(self):
        wxInitAllImageHandlers()
        self.frame = MyAppFrame(None, -1, "")
        self.SetTopWindow(self.frame)
        self.frame.Show(True)
        return True


def chg_box(color, component):
    BOX_MAX = 10
    STEP = 1
    #this is to map the component name to the box
    if( component == "queue-manager" ):
        boxname = "box1"
    elif( component == "process-manager" ):
        boxname = "box2"
    elif( component == "scheduler" ):
        boxname = "box3"
    elif( component == "build-system" ):
        boxname = "box4"
    elif( component == "cluster-hardware" ):
        boxname = "box5"
    elif( component == "file-stager" ):
        boxname = "box6"
    elif( component == "node-state-manager" ):
        boxname = "box7"
    elif( component == "service-directory" ):
        boxname = "box8"
    elif( component == "foo" ):
        #this is for testing purposes
        boxname = "box%s"%randrange(1,BOX_MAX + 1)
    canvas = getattr(app.frame.canvas, boxname).GetCanvas()
    shape = getattr(app.frame.canvas, boxname).GetShape()
    dc = wxClientDC(canvas)
    origX = shape.GetX()
    origY = shape.GetY()
    tempY = -25
    while tempY <= 25:
        newX = origX + sqrt( 625 - tempY**2 )
        newY = origY + tempY
        canvas.PrepareDC(dc)
        shape.Move(dc, newX, newY)
        canvas.Refresh()    # can take args, e.g False as first arg (documentation?)
        tempY = tempY + STEP
    tempY = 25
    while tempY >= -25:
        newX = origX - sqrt( 625 - tempY**2 )
        newY = origY + tempY
        canvas.PrepareDC(dc)
        shape.Move(dc, newX, newY)
        canvas.Refresh()    # can take args, e.g False as first arg (documentation?)
        tempY = tempY - STEP
    while newY < origY:
        canvas.PrepareDC(dc)
        shape.Move(dc, origX, newY)
        canvas.Refresh()
        newY = newY + STEP
    canvas.PrepareDC(dc)
    shape.Move(dc, origX, origY)
    canvas.Refresh()
        
        
#    origbrush = getattr(app.frame.canvas, "%sBrush"%boxname)
#    shapebrush.SetColour(wxNamedColour(color))
#    canvas.Refresh()    # can take args, e.g False as first arg (documentation?)
#    shapebrush.SetColour(origbrush.GetColour())
#    canvas.Refresh()
    

if __name__ == "__main__":
    app = Main()
    app.MainLoop()

